//$$---- Active Form CPP ---- (stActiveFormSource)
//---------------------------------------------------------------------------
#include <math.h>
#include <dos.h>
#include <windows.h>
#include <tlhelp32.h>

#include <vcl.h>
#pragma hdrstop
#include <atl\atlvcl.h>

#include "wacherImpl1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
Twacher *wacher;
float min,hour; 
//---------------------------------------------------------------------------
__fastcall Twacher::Twacher(HWND ParentWindow)
        : TActiveForm(ParentWindow)
{
}
//---------------------------------------------------------------------------

STDMETHODIMP TwacherImpl::_set_Font(IFontDisp** Value)
{
  try
  {
    const DISPID dispid = -512;
    if (FireOnRequestEdit(dispid) == S_FALSE)
      return S_FALSE;
    SetVclCtlProp(m_VclCtl->Font, Value);
    FireOnChanged(dispid);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::get_Active(VARIANT_BOOL* Value)
{
  try
  {
   *Value = m_VclCtl->Active;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::get_AlignDisabled(VARIANT_BOOL* Value)
{
  try
  {
   *Value = m_VclCtl->AlignDisabled;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::get_AutoScroll(VARIANT_BOOL* Value)
{
  try
  {
   *Value = m_VclCtl->AutoScroll;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::get_AutoSize(VARIANT_BOOL* Value)
{
  try
  {
   *Value = m_VclCtl->AutoSize;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::get_AxBorderStyle(TxActiveFormBorderStyle* Value)
{
  try
  {
   *Value = (TxActiveFormBorderStyle)(m_VclCtl->AxBorderStyle);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::get_BorderWidth(long* Value)
{
  try
  {
   *Value = (long)(m_VclCtl->BorderWidth);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::get_Caption(BSTR* Value)
{
  try
  {
    *Value = WideString(m_VclCtl->Caption).Copy();
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::get_Color(::OLE_COLOR* Value)
{
  try
  {
   *Value = (::OLE_COLOR)(m_VclCtl->Color);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::get_DoubleBuffered(VARIANT_BOOL* Value)
{
  try
  {
   *Value = m_VclCtl->DoubleBuffered;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::get_DropTarget(VARIANT_BOOL* Value)
{
  try
  {
   *Value = m_VclCtl->DropTarget;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::get_Enabled(VARIANT_BOOL* Value)
{
  try
  {
   *Value = m_VclCtl->Enabled;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::get_Font(IFontDisp** Value)
{
  try
  {
    GetVclCtlProp(m_VclCtl->Font, Value);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::get_HelpFile(BSTR* Value)
{
  try
  {
    *Value = WideString(m_VclCtl->HelpFile).Copy();
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::get_KeyPreview(VARIANT_BOOL* Value)
{
  try
  {
   *Value = m_VclCtl->KeyPreview;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::get_PixelsPerInch(long* Value)
{
  try
  {
   *Value = (long)(m_VclCtl->PixelsPerInch);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::get_PrintScale(TxPrintScale* Value)
{
  try
  {
   *Value = (TxPrintScale)(m_VclCtl->PrintScale);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::get_Scaled(VARIANT_BOOL* Value)
{
  try
  {
   *Value = m_VclCtl->Scaled;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::get_Visible(VARIANT_BOOL* Value)
{
  try
  {
   *Value = m_VclCtl->Visible;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::get_VisibleDockClientCount(long* Value)
{
  try
  {
   *Value = (long)(m_VclCtl->VisibleDockClientCount);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::set_AutoScroll(VARIANT_BOOL Value)
{
  try
  {
    const DISPID dispid = 2;
    if (FireOnRequestEdit(dispid) == S_FALSE)
     return S_FALSE;
    m_VclCtl->AutoScroll = Value;
    FireOnChanged(dispid);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::set_AutoSize(VARIANT_BOOL Value)
{
  try
  {
    const DISPID dispid = 3;
    if (FireOnRequestEdit(dispid) == S_FALSE)
     return S_FALSE;
    m_VclCtl->AutoSize = Value;
    FireOnChanged(dispid);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::set_AxBorderStyle(TxActiveFormBorderStyle Value)
{
  try
  {
    const DISPID dispid = 4;
    if (FireOnRequestEdit(dispid) == S_FALSE)
     return S_FALSE;
    m_VclCtl->AxBorderStyle = (TActiveFormBorderStyle)(Value);
    FireOnChanged(dispid);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::set_BorderWidth(long Value)
{
  try
  {
    const DISPID dispid = 5;
    if (FireOnRequestEdit(dispid) == S_FALSE)
     return S_FALSE;
    m_VclCtl->BorderWidth = (int)(Value);
    FireOnChanged(dispid);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::set_Caption(BSTR Value)
{
  try
  {
    const DISPID dispid = -518;
    if (FireOnRequestEdit(dispid) == S_FALSE)
      return S_FALSE;
    m_VclCtl->Caption = AnsiString(Value);
    FireOnChanged(dispid);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::set_Color(::OLE_COLOR Value)
{
  try
  {
    const DISPID dispid = -501;
    if (FireOnRequestEdit(dispid) == S_FALSE)
     return S_FALSE;
    m_VclCtl->Color = (TColor)(Value);
    FireOnChanged(dispid);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::set_DoubleBuffered(VARIANT_BOOL Value)
{
  try
  {
    const DISPID dispid = 13;
    if (FireOnRequestEdit(dispid) == S_FALSE)
     return S_FALSE;
    m_VclCtl->DoubleBuffered = Value;
    FireOnChanged(dispid);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::set_DropTarget(VARIANT_BOOL Value)
{
  try
  {
    const DISPID dispid = 11;
    if (FireOnRequestEdit(dispid) == S_FALSE)
     return S_FALSE;
    m_VclCtl->DropTarget = Value;
    FireOnChanged(dispid);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::set_Enabled(VARIANT_BOOL Value)
{
  try
  {
    const DISPID dispid = -514;
    if (FireOnRequestEdit(dispid) == S_FALSE)
     return S_FALSE;
    m_VclCtl->Enabled = Value;
    FireOnChanged(dispid);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::set_Font(IFontDisp* Value)
{
  try
  {
    const DISPID dispid = -512;
    if (FireOnRequestEdit(dispid) == S_FALSE)
      return S_FALSE;
    SetVclCtlProp(m_VclCtl->Font, Value);
    FireOnChanged(dispid);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::set_HelpFile(BSTR Value)
{
  try
  {
    const DISPID dispid = 12;
    if (FireOnRequestEdit(dispid) == S_FALSE)
      return S_FALSE;
    m_VclCtl->HelpFile = AnsiString(Value);
    FireOnChanged(dispid);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::set_KeyPreview(VARIANT_BOOL Value)
{
  try
  {
    const DISPID dispid = 6;
    if (FireOnRequestEdit(dispid) == S_FALSE)
     return S_FALSE;
    m_VclCtl->KeyPreview = Value;
    FireOnChanged(dispid);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::set_PixelsPerInch(long Value)
{
  try
  {
    const DISPID dispid = 7;
    if (FireOnRequestEdit(dispid) == S_FALSE)
     return S_FALSE;
    m_VclCtl->PixelsPerInch = (int)(Value);
    FireOnChanged(dispid);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::set_PrintScale(TxPrintScale Value)
{
  try
  {
    const DISPID dispid = 8;
    if (FireOnRequestEdit(dispid) == S_FALSE)
     return S_FALSE;
    m_VclCtl->PrintScale = (TPrintScale)(Value);
    FireOnChanged(dispid);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::set_Scaled(VARIANT_BOOL Value)
{
  try
  {
    const DISPID dispid = 9;
    if (FireOnRequestEdit(dispid) == S_FALSE)
     return S_FALSE;
    m_VclCtl->Scaled = Value;
    FireOnChanged(dispid);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};


STDMETHODIMP TwacherImpl::set_Visible(VARIANT_BOOL Value)
{
  try
  {
    const DISPID dispid = 1;
    if (FireOnRequestEdit(dispid) == S_FALSE)
     return S_FALSE;
    m_VclCtl->Visible = Value;
    FireOnChanged(dispid);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_Iwacher);
  }
  return S_OK;
};



void __fastcall TwacherImpl::ActivateEvent(TObject *Sender)
{
  Fire_OnActivate();
}


void __fastcall TwacherImpl::ClickEvent(TObject *Sender)
{
  Fire_OnClick();
}


void __fastcall TwacherImpl::CreateEvent(TObject *Sender)
{
  Fire_OnCreate();
}


void __fastcall TwacherImpl::DblClickEvent(TObject *Sender)
{
  Fire_OnDblClick();
}


void __fastcall TwacherImpl::DeactivateEvent(TObject *Sender)
{
  Fire_OnDeactivate();
}


void __fastcall TwacherImpl::DestroyEvent(TObject *Sender)
{
  Fire_OnDestroy();
}


void __fastcall TwacherImpl::KeyPressEvent(TObject *Sender, char &Key)
{
  short TempKey;
  TempKey = (short)Key;
  Fire_OnKeyPress(&TempKey);
  Key = (short)TempKey;
}


void __fastcall TwacherImpl::PaintEvent(TObject *Sender)
{
  Fire_OnPaint();
}

void __fastcall Twacher::Timer1Timer(TObject *Sender)
{
 static int dual=0;
 int index;
 TDateTime date;
 unsigned short h,m,s,p;
 HANDLE HS;
 PROCESSENTRY32 P;
 if (Image1->Visible)
 {
  Image1->Canvas->CopyRect(TRect(0,0,150,150),Image2->Canvas,TRect(0,0,150,150));
  date=Time();
  date.DecodeTime(&h,&m,&s,&p);
  min=(float)m*6;
  hour=(float)h*30+(float)m*0.5;
  Image1->Canvas->Pen->Color=clBlack;
  Image1->Canvas->Pen->Width=4;
  Image1->Canvas->MoveTo(75,75);
  Image1->Canvas->LineTo(75+(int)(sin(hour*M_PI/180)*30),75-(int)(cos(hour*M_PI/180)*30));
  Image1->Canvas->Pen->Color=0x881100;
  Image1->Canvas->Pen->Width=2;
  Image1->Canvas->MoveTo(75,75);
  Image1->Canvas->LineTo(75+(int)(sin(min*M_PI/180)*50),75-(int)(cos(min*M_PI/180)*50));
 }
 else
 {
  dual++;
  if (dual==2)
  {
   for (index=0;index<ListBox1->Items->Count;index++)
   {
    CloseHandle((HANDLE)ListBox1->Items->Objects[index]);
   }
   ListBox1->Clear();
   HS=CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS,0);
   P.dwSize=sizeof(PROCESSENTRY32);
   if (Process32First(HS,&P))
   {
    do
    {
     ListBox1->AddItem(P.szExeFile,(TObject *)OpenProcess(PROCESS_ALL_ACCESS,true,P.th32ProcessID));
    }
    while (Process32Next(HS,&P));
    CloseHandle(HS);
   }
   dual=0;
  }
 }

}
//---------------------------------------------------------------------------

void __fastcall Twacher::Image1DblClick(TObject *Sender)
{
 ListBox1->Visible=true;
 Button1->Visible=true;
 Button2->Visible=true;
 Image1->Visible=false;
 ActiveFormCreate(Sender);
}
//---------------------------------------------------------------------------
void __fastcall Twacher::Button1Click(TObject *Sender)
{
 Image1->Visible=true;
 ListBox1->Visible=false;
 Button1->Visible=false;
 Button2->Visible=false;
 ActiveFormCreate(Sender);
}
//---------------------------------------------------------------------------
void __fastcall Twacher::ActiveFormDestroy(TObject *Sender)
{
 int index;
 for (index=0;index<ListBox1->Items->Count;index++)
 {
  CloseHandle((HANDLE)ListBox1->Items->Objects[index]);
 }
 ListBox1->Clear();
}
//---------------------------------------------------------------------------
void __fastcall Twacher::ListBox1DblClick(TObject *Sender)
{
 if (Application->MessageBoxA("Are you sure that will stop the process","Warning",MB_OKCANCEL|MB_ICONWARNING)==IDOK)
 {
  TerminateProcess((HANDLE)ListBox1->Items->Objects[ListBox1->ItemIndex],5);
  WaitForSingleObject((HANDLE)ListBox1->Items->Objects[ListBox1->ItemIndex],1000);
  ActiveFormCreate(Sender);
 }
}
//---------------------------------------------------------------------------


void __fastcall Twacher::ActiveFormCreate(TObject *Sender)
{
 int index;
 HANDLE HS;
 PROCESSENTRY32 P;
 TDateTime date;
 unsigned short h,m,s,p;
 Image1->Canvas->CopyRect(TRect(0,0,150,150),Image2->Canvas,TRect(0,0,150,150));
 date=Time();
 date.DecodeTime(&h,&m,&s,&p);
 min=(float)m*6;
 hour=(float)h*30+(float)m*0.5;
 Image1->Canvas->Pen->Color=clBlack;
 Image1->Canvas->Pen->Width=4;
 Image1->Canvas->MoveTo(75,75);
 Image1->Canvas->LineTo(75+(int)(sin(hour*M_PI/180)*30),75-(int)(cos(hour*M_PI/180)*30));
 Image1->Canvas->Pen->Color=0x881100;
 Image1->Canvas->Pen->Width=2;
 Image1->Canvas->MoveTo(75,75);
 Image1->Canvas->LineTo(75+(int)(sin(min*M_PI/180)*50),75-(int)(cos(min*M_PI/180)*50));
 for (index=0;index<ListBox1->Items->Count;index++)
   {
    CloseHandle((HANDLE)ListBox1->Items->Objects[index]);
   }
 ListBox1->Clear();
 HS=CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS,0);
 P.dwSize=sizeof(PROCESSENTRY32);
 if (Process32First(HS,&P))
 {
 do
 {
    ListBox1->AddItem(P.szExeFile,(TObject *)OpenProcess(PROCESS_ALL_ACCESS,true,P.th32ProcessID));
 }
 while (Process32Next(HS,&P));
 CloseHandle(HS);
 }

}
//---------------------------------------------------------------------------
void __fastcall Twacher::Button2Click(TObject *Sender)
{
 if (Application->MessageBoxA("Are you sure that will stop the process","Warning",MB_OKCANCEL|MB_ICONWARNING)==IDOK)
 {
  TerminateProcess((HANDLE)ListBox1->Items->Objects[ListBox1->ItemIndex],5);
  WaitForSingleObject((HANDLE)ListBox1->Items->Objects[ListBox1->ItemIndex],1000);
  ActiveFormCreate(Sender);
 }
}
//---------------------------------------------------------------------------
